require 'test_helper'

class IdeasControllerTest < ActionController::TestCase
  test "should get index" do
    get :index
    assert_response :success
    assert_not_nil assigns(:ideas)
  end

  test "should get new" do
    get :new
    assert_response :success
  end

  test "should create idea" do
    assert_difference('Idea.count') do
      post :create, :idea => valid_options_for_idea
    end

    assert_redirected_to idea_path(assigns(:idea))
  end

  test "should go back to new when trying to create an invalid idea" do
    unless valid_options_for_idea.empty?
      assert_no_difference('Idea.count') do
        post :create, :idea => invalid_options_for_idea
      end
    
      assert_template "new"
    end
  end

  test "should show idea" do
    get :show, :id => ideas(:one).id
    assert_response :success
  end

  test "should get edit" do
    get :edit, :id => ideas(:one).id
    assert_response :success
  end

  test "should update idea" do
    put :update, :id => ideas(:one).id, :idea => { }
    assert_redirected_to idea_path(assigns(:idea))
  end

  test "should go back to edit if updating an idea with invalid parameters" do
    unless valid_options_for_idea.keys.empty?
      put :update, :id => ideas(:one).id, :idea => { valid_options_for_idea.keys.first => nil }
      assert_template "edit"
    end
  end

  test "should destroy idea" do
    assert_difference('Idea.count', -1) do
      delete :destroy, :id => ideas(:one).id
    end

    assert_redirected_to ideas_path
  end
end
